Subject: Re: #1179 not closed? Re: Ticket status, March 24

From: Harald Alvestrand <[email-masked]>
Date: Mon, 17 Apr 2006 12:23:44 +0200

I am not happy with Charles' text on this issue. Trying again, based on 
the -07 NOTE:

    NOTE: The [RFC2822] specification sometimes uses [FWS] at the 
beginning or end of ABNF
   describing a header field content. This specification uses *WSP in 
such cases, also in cases where
   this specification redefines constructs from [RFC2822]. This is done 
for consistency with the
   restriction described here, but the restriction applies to all header 
fields, not just those
   where ABNF is defined in this document.

Charles' proposed text was:

   NOTE: Where some ABNF rule forbids <comment>s at the beginning or end
   of a header field content, this specification uses *WSP rather than
   [FWS] {as used in [RFC 2822]}. This is done for consistency with the
   restriction described above, but that restriction is still needed for
   the cases where [CFWS] appears.

If anyone wishes to make further changes, or prefers Charles' version, 
please speak up.

                    Harald

Charles Lindsey wrote:
> In <[email-masked]> Harald Alvestrand <[email-masked]> writes:
>
>   
>> Charles Lindsey wrote:
>>     
>
>   
>>> No, that is not correct (RFC 2822 does not contain "[WSP]" anywhere, and
>>> tends to use [CFWS] at the beginning _and_end_ of header field bodies,
>>> except for <unstructured>, where it is of course [FWS]).
>>>
>>> So what you would need to say is:
>>>
>>> NOTE: The [RFC 2822] specification uses, directly or indirectly, [CFWS]
>>> (occasionally [FWS]) at the beginning and end of the ABNF for header field
>>> bodies. In contexts where <comment>s are disallowed, this specification
>>> uses *WSP rather than [FWS]. This is done for consistency with the
>>> restriction described above, but that restriction applies to all header
>>> fields, not just those where *WSP is used in this document.
>>>
>>> You might be able to prune that a little.
>>>
>>>  
>>>
>>>       
>> What went into -07 section 2.2 was:
>>     
>
>   
>>         NOTE: The [RFC2822] specification uses [FWS] at the beginning
>>         of ABNF for header field content.  This specification uses
>>         *WSP.  This is done for consistency with the restriction
>>         described here, but the restriction applies to all header
>>         fields, not just those where ABNF is defined in this document.
>>     
>
>   
>> So the bug you pointed out ([WSP]) was fixed, but not the generic claim 
>> that RFC2822 uses FWS.
>>     
>
> Ah! I had not spotted that small change in the actual draft-07 text.
>
>   
>> Replacing [CFWS] with *WSP removes the possibility of starting a header 
>> field with a comment, so it's a change that goes beyond the "no line of 
>> a header field body can be empty" restriction.
>>     
>
>   
>> So my questions:
>>     
>
>   
>> 1) Have we replaced [CFWS] with *WSP anywhere?
>>     
>
> No.
>
>   
>> 2) Do we need to change the word "uses", and if so, to what?
>>     
>
> I had two concerns with the present text.
> a) It does not make it clear that it leaves the common case of [CFWS]
> untouched;
> b) It applies at the end as well as the beginning of the affected rules.
>
> The text I suggested (see above) tells the truth, but is a little verbose.
> Let me try something a little shorter:
>
>    NOTE: Where some ABNF rule forbids <comment>s at the beginning or end
>    of a header field content, this specification uses *WSP rather than
>    [FWS] {as used in [RFC 2822]}. This is done for consistency with the
>    restriction described above, but that restriction is still needed for
>    the cases where [CFWS] appears.
>
> The bit in {...} could be omitted. I think <unstructured> in the only
> actual example in 2822
>
>

---

From: "Charles Lindsey" <[email-masked]>
Date: Tue, 18 Apr 2006 16:55:03 GMT

>If anyone wishes to make further changes, or prefers Charles' version, 

I am happy with either text.

-- 
Charles H. Lindsey ---------At Home, doing my own thing------------------------
Tel: +44 161 436 6131 Fax: +44 161 436 6133   Web: http://www.cs.man.ac.uk/~chl
Email: [email-masked]      Snail: 5 Clerewood Ave, CHEADLE, SK8 3JU, U.K.
PGP: 2C15F1A9      Fingerprint: 73 6D C2 51 93 A0 01 E7 65 E8 64 7E 14 A4 AB A5